
class Agent {
  // current position
  float x;
  float y;
  // current direction
  // 0 is North, 1 is East, 2 is South, 3 is West
  int direction;
  // line shade
  float shade;

  // whether the agent is dead or not
  boolean dead;

  // create a new agent 
  Agent() {
    x = random(0, width);
    y = random(0, height);
    direction = int(random(0, 5));
    shade = random(0, 255);
    dead = false;
  }

  void update() {

    if (!dead) {
      // save the last position
      float px = x;
      float py = y;

      // decide if it changes direction
      if (random(100) < probTurn) {
        direction = (direction + 1) % 4;
      }

      // how far to step this time
      float step = random(1, maxStep);
      // take the step according to direction
      if (direction == 0) {
        y -= step;
      } else if (direction == 1) {
        x += step;
      } else if (direction == 2) {
        y += step;
      } else if (direction == 3) {
        x -= step;
      }

      // draw the line
      stroke(shade, 100);
      line(px, py, x, y);

      // kill if it leaves the canvas
      if (x < 0 || x > width - 1 || y < 0 || y > height - 1) {
        dead = true;
      }
    }
  }
}