
class Agent {

  // current position
  float x;
  float y;

  // current direction
  int direction;

  // stroke weight and shade
  float weight; 
  float shade;
  float hue;

  // whether the agent is dead or not
  boolean dead;

  // create a new agent
  Agent() {
    float m = 0.02 * height; // margin
    x = random(m, width - m);
    y = random(m, height - m);
    direction = int(random(0, 5));
    shade = random(0, 255);
    weight = 1;
    dead = false;

    // pick a hue
    hue = (baseHue + random(0, 60)) % 360;
  }

  void update() {

    if (!dead) {
      // save the last position
      float px = x;
      float py = y;

      // move to next position
      // decide if it changes direction
      if (random(100) < probTurn) {
        direction = (direction + 1) % 4;
      }

      // how far to step this time
      float step = random(1, maxStep);
      // take the step according to direction
      if (direction == 0) {
        y -= step;
      } else if (direction == 1) {
        x += step;
      } else if (direction == 2) {
        y += step;
      } else if (direction == 3) {
        x -= step;
      }

      // draw the line
      strokeWeight(weight);
      stroke(hue, 100, shade, 33);
      line(px, py, x, y);

      // kill the agent if it leaves the canvas
      if (x < 0 || x > width - 1 || y < 0 || y > height - 1) {
        dead = true;
      }

      // kill the agent if it gets too big
      if (weight > 0.25 * height) {
        dead = true;
      }
    }
  }

}