
// maximum step size to take
float maxStep = 10;
// the probability % to turn
float probTurn = 5;
// base colour
float baseHue = 180;

// the agents
Agent[] a;

void setup() {
  // try commenting size and uncomment fullscreen
  //size(300, 300);
  fullScreen();

  
  colorMode(HSB, 360, 100, 100, 100);
  background(0);
  // create all the agents
  a = new Agent[height / 2];
  for (int i = 0; i < a.length; i++) {
    a[i] = new Agent();
  }
}

void draw() {

  // update all the agents
  for (int i = 0; i < a.length; i++) {
    a[i].update();
    // create a new agent if this one died
    if (a[i].dead) {
      a[i] = new Agent();
    }
  }

  // if two agents touch, then kill one and give the weight to the other
  for (int i = 0; i < a.length; i++) {
    for (int j = i + 1; j < a.length; j++) {
      if (!a[i].dead && !a[j].dead) {
        float threshold = a[i].weight / 2 + a[j].weight / 2;
        float d = dist(a[i].x, a[i].y, a[j].x, a[j].y);
        if (d < threshold) {
          if (a[i].weight > a[j].weight) {
            a[i].weight += a[j].weight;
            a[j].dead = true;
          } else {
            a[j].weight += a[i].weight;
            a[i].dead = true;
          }
        }
      }
    }
  }

  // interactively adjust agent parameters
  maxStep = map(mouseX, 0, width - 1, 1, 30);
  probTurn = map(mouseY, 0, height - 1, 3, 50);
}

void keyPressed() {
  if (key == ' ') {
  background(0);
  } else if (key == '[') {
     baseHue -= 5; 
     if (baseHue < 0) {
       baseHue = 360;
     }
  } else if (key == ']') {
     baseHue += 5; 
     if (baseHue > 360) {
        baseHue = 0; 
     }
  }
}